from ._claims import ADMIN_CLAIMS, AddUserClaim as AddUserClaim, DIRECT_CLAIMS, DeleteUserClaim as DeleteUserClaim, GenerateRequestClientCertificateOTPClaim as GenerateRequestClientCertificateOTPClaim, GenerateRequestServiceCertificateOTPClaim as GenerateRequestServiceCertificateOTPClaim, GetCertificateClaim as GetCertificateClaim, GetUserClaim as GetUserClaim, PROXY_CLAIMS, ProxyGenerateClientOTPClaim as ProxyGenerateClientOTPClaim, ProxyGenerateServiceOTPClaim as ProxyGenerateServiceOTPClaim, ProxyGetCertificateClaim as ProxyGetCertificateClaim, ProxyRequestClientCertificateClaim as ProxyRequestClientCertificateClaim, ProxyRequestServiceCertificateClaim as ProxyRequestServiceCertificateClaim, ProxyRevokeCertificateClaim as ProxyRevokeCertificateClaim, ReadAuditorDataClaim as ReadAuditorDataClaim, ReadCDNARateLimiterDataClaim as ReadCDNARateLimiterDataClaim, ReadRateLimiterDataClaim as ReadRateLimiterDataClaim, RequestAPITokenClaim as RequestAPITokenClaim, RequestClientCertificateClaim as RequestClientCertificateClaim, RequestClientCredentialsClaim as RequestClientCredentialsClaim, RequestServiceCertificateClaim as RequestServiceCertificateClaim, ResourceRateLimitClaim as ResourceRateLimitClaim, RevokeCertificateClaim as RevokeCertificateClaim, SearchEndpointsClaim as SearchEndpointsClaim, UpdateUserClaim as UpdateUserClaim, WriteAuditorDataClaim as WriteAuditorDataClaim, WriteCDNARateLimiterDataClaim as WriteCDNARateLimiterDataClaim, WriteRateLimiterDataClaim as WriteRateLimiterDataClaim
from .base import AuthClaim as AuthClaim, CloudAdminClaim as CloudAdminClaim
from .granting import GRANTING_CLAIMS, GrantAddUserClaim as GrantAddUserClaim, GrantCloudAdminClaim as GrantCloudAdminClaim, GrantDeleteUserClaim as GrantDeleteUserClaim, GrantGenerateRequestClientCertificateOTPClaim as GrantGenerateRequestClientCertificateOTPClaim, GrantGenerateRequestServiceCertificateOTPClaim as GrantGenerateRequestServiceCertificateOTPClaim, GrantGetUserClaim as GrantGetUserClaim, GrantProxyGenerateClientOTPClaim as GrantProxyGenerateClientOTPClaim, GrantProxyGenerateServiceOTPClaim as GrantProxyGenerateServiceOTPClaim, GrantProxyGetCertificateClaim as GrantProxyGetCertificateClaim, GrantProxyRequestClientCertificateClaim as GrantProxyRequestClientCertificateClaim, GrantProxyRequestServiceCertificateClaim as GrantProxyRequestServiceCertificateClaim, GrantProxyRevokeCertificateClaim as GrantProxyRevokeCertificateClaim, GrantRequestClientCertificateClaim as GrantRequestClientCertificateClaim, GrantRequestServiceCertificateClaim as GrantRequestServiceCertificateClaim, GrantSearchEndpointsClaim as GrantSearchEndpointsClaim, GrantUpdateUserClaim as GrantUpdateUserClaim, GrantingClaim as GrantingClaim
from .granting.results import BaseGrantingResult as BaseGrantingResult, FailedGrantingResult as FailedGrantingResult, SuccessfulGrantingResult as SuccessfulGrantingResult

__all__ = ['CLAIMS', 'OTP_CLAIMS', 'AuthClaim', 'CloudAdminClaim', 'RequestServiceCertificateClaim', 'GrantRequestServiceCertificateClaim', 'RequestClientCertificateClaim', 'GrantRequestClientCertificateClaim', 'ProxyRequestClientCertificateClaim', 'ProxyRequestServiceCertificateClaim', 'GrantProxyRequestClientCertificateClaim', 'GrantProxyRequestServiceCertificateClaim', 'GetCertificateClaim', 'ProxyGetCertificateClaim', 'GrantProxyGetCertificateClaim', 'RevokeCertificateClaim', 'ProxyRevokeCertificateClaim', 'GrantProxyRevokeCertificateClaim', 'GenerateRequestServiceCertificateOTPClaim', 'GrantGenerateRequestServiceCertificateOTPClaim', 'GenerateRequestClientCertificateOTPClaim', 'GrantGenerateRequestClientCertificateOTPClaim', 'ProxyGenerateClientOTPClaim', 'ProxyGenerateServiceOTPClaim', 'GrantProxyGenerateClientOTPClaim', 'GrantProxyGenerateServiceOTPClaim', 'AddUserClaim', 'GrantAddUserClaim', 'DeleteUserClaim', 'GrantDeleteUserClaim', 'UpdateUserClaim', 'GrantUpdateUserClaim', 'GetUserClaim', 'GrantGetUserClaim', 'SearchEndpointsClaim', 'GrantSearchEndpointsClaim', 'ReadAuditorDataClaim', 'WriteAuditorDataClaim', 'GrantCloudAdminClaim', 'GrantingClaim', 'BaseGrantingResult', 'FailedGrantingResult', 'SuccessfulGrantingResult', 'ReadRateLimiterDataClaim', 'WriteRateLimiterDataClaim', 'ReadCDNARateLimiterDataClaim', 'WriteCDNARateLimiterDataClaim', 'ResourceRateLimitClaim', 'RequestAPITokenClaim', 'RequestClientCredentialsClaim']

CLAIMS = DIRECT_CLAIMS | PROXY_CLAIMS | ADMIN_CLAIMS | GRANTING_CLAIMS
OTP_CLAIMS = RequestServiceCertificateClaim | RequestClientCertificateClaim | GetCertificateClaim | RevokeCertificateClaim
